#include <stdio.h>
#include <allegro.h>

#include "mapedit.h"
#include "map.h"

int show_background(void)
{
   blit(TGA_Background,screen,0,0,0,0,320,200);
   return(0);
}

int load_tiles(void)
{
   int tempx,tempy,tmptile;
   PALLETE pallete1;

   tmptile=0;
   for(tempy=0;tempy<192;tempy+=16)
   {
      for(tempx=0;tempx<320;tempx+=16)
      {
         TGA_Tileset[tmptile]=load_bitmap("GRAFIX\\BL_16X16.TGA",pallete1);
         blit(TGA_MapTiles,TGA_Tileset[tmptile],tempx,tempy,0,0,16,16);
         tmptile++;
      }
   }

   return(0);
}

int load_map(void)
{
   FILE *infile;
   int temp1,temp2;

   infile = fopen("map.dat", "rb");
   if (infile == NULL)
   {
      return(0);
   }
   fread(&Map,sizeof(Map),1,infile);
   fclose(infile);
   playwav("AUDIO\\MENUCHNG.WAV");
   return(0);
}

int save_map(void)
{
   FILE *outfile;

   outfile = fopen("map.dat", "wb");
   if (outfile == NULL)
   {
      printf("\n\n Fatal error:  could not open %s for output.\n");
      exit(1);
   }
   fwrite(&Map,sizeof(Map),1,outfile);
   fclose(outfile);
   playwav("AUDIO\\MENUCHNG.WAV");
   return(0);
}

int display_map(void)
{
   int tempx,tempy;

   showtranspict("GRAFIX\\BL_16X16.TGA",0,0,5,55,150,59);

   for(tempy=0;tempy<160;tempy+=16)
   {
      for(tempx=0;tempx<272;tempx+=16)
      {
         blit(TGA_Tileset[Map[(tempx/16)+PL_player.x][(tempy/16)+PL_player.y].tile],screen,0,0,tempx,tempy,16,16);
         masked_blit(TGA_Tileset[Map[(tempx/16)+PL_player.x][(tempy/16)+PL_player.y].layer2],screen,0,0,tempx,tempy,16,16);
      }
   }
   masked_blit(TGA_TileSelect,screen,0,0,128,64,16,16);
   showtiles();
   clear_keybuf();
   return(0);
}

int display_map_fast(void)
{
   int tempx,tempy;

   showtranspict("GRAFIX\\BL_16X16.TGA",0,0,5,55,150,59);

   for(tempy=0;tempy<160;tempy+=16)
   {
      for(tempx=0;tempx<272;tempx+=16)
      {
         blit(TGA_Tileset[Map[(tempx/16)+PL_player.x][(tempy/16)+PL_player.y].tile],screen,0,0,tempx,tempy,16,16);
      }
   }
   masked_blit(TGA_TileSelect,screen,0,0,128,64,16,16);
   showtiles();
   return(0);
}

int showtiles(void)
{
   int temp1;
   for(temp1=0;temp1<19;temp1++)
   {
      blit(TGA_Tileset[temp1+PL_player.curtile],screen,0,0,5+(temp1*16),175,16,16);
   }
   masked_blit(TGA_TileSelect,screen,0,0,5,175,16,16);
   return(0);
}

int do_editor(void)
{
   return(0);
}

